# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ Web Forum : init.cgi - 2019/12/31
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'Web Forum';
#┌─────────────────────────────────
#│[ 注意事項 ]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Web Forum v8.01 Multi 2.0 : init.cgi - 2023/10/13
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

#============================================================
# ■ 基本設定
#============================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# 画像アップを許可する
# 0=no 1=yes
$cf{image_upl} = 1;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 1;

# 掲示板タイトル
$cf{bbs_title} = 'Web Forum v8.01 Multi 2.0';

# 最大記事数
$cf{maxlog} = 200;

# スクリプトURL【URLパス】
$cf{bbs_cgi} = './wforum.cgi';

# 管理ファイルURL【URLパス】
$cf{admin_cgi} = './admin.cgi';

# 書込ファイルURL【URLパス】
$cf{post_cgi} = './post.cgi';

# ログファイル【サーバパス】
$cf{logfile} = './data/log.cgi';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# 画像ディレクトリ（ツリー）
$cf{tree_ico} = './cmn/img';

# 画像ディレクトリ（画像アップを許可するとき）
# → 順に、サーバパス、URLパス
$cf{upldir} = './upl';
$cf{uplurl} = './upl';

# アイコンディレクトリ【URLパス】
$cf{icourl} = './cmn/ico';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = "./tmpl";

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'PowerPoint-icon.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	};

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 1;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF

#------------------------------------------------------------#

# 追加添付ファイル入力フォーム数最大値 (変更不可)
$cf{add_usermax} = 5;

# 追加添付ファイル入力フォーム数（MAX=5）
# 最大追加数は５です。５以上はアップロード不可。
# ex. ５の場合は[0,1,2,3,4,5]、または[0,1,3,5]などに変更。
$cf{addattach} = [0,1,2,3,4,5];

# 追加添付ファイル入力フォーム数の初期値
# 閲覧者が初めてこの掲示板を開いた時に見る入力フォームの行数です。
# 変更可能な数値は「0～5」までの数値です。初期数値は「1」に設定されています。
$cf{attach_defo} = 1;

# 入力フォーム数変更後戻るアドレス【URLパス】
$cf{checge_url} = './wforum.cgi?mode=form';

# -------------------------------------------------------------- #

# URL自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# 記事にNEWマークを付ける時間（時間単位）
$cf{new_time} = 48;

# NEWマークの表示形態
#  → 画像を使用する場合には $newmark = '<img src="./img/new.gif">';
#     というように IMGタグを記述してもよい
$cf{new_mark} = '<img src="./cmn/ico/new04.png" border="0">';

# ミニカウンタの設置
# → 0=no 1=テキスト 2=画像
$cf{counter} = 1;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#ffffff ";

# カウンタファイル【サーバパス】
$cf{cntfile} = './data/count.dat';

# 画像のとき：画像ディレクトリを指定【URLパス】
# → 最後は必ず / で閉じない
$cf{gif_path} = "./cmn/img";

# アイコン画像【URLパス】
# → 順に [pagetop][ホームページ]
$cf{ico_home} = "./cmn/icon/home.gif";
$cf{ico_ptop} = "./cmn/icon/ptop.png";

# 記事番号の色（標準）
$cf{num_st_col} = "#008000";

# 記事番号の色（強調時）
$cf{num_em_col} = "#dd0000";

# 新着表示のページ当たり表示件数
$cf{new_pgbtn} = 10;

# 頁あたりツリー表示数
$cf{p_tree} = 5;

# アルバム表示１ページあたりの記事(返信含む)表示件数
$cf{max_albums} = 5;

# 「記事タイトル」「名前」の最大長（文字数：半角文字換算）
$cf{sub_length} = 50;
$cf{nam_length} = 30;

# レスがついたらツリー毎トップへ移動 (0=no 1=yes)
$cf{top_sort} = 1;

# レスは下から順に付ける (0=no 1=yes)
$cf{bot_res} = 1;

# 引用部色変更
#  → ここに色指定を行うと「引用部」を色変更します
#  → この機能を使用しない場合は何も記述しないで下さい ($refcol="";)
$cf{ref_col} = "#804000";

# 戻り先URL【URLパス】
$cf{homepage} = "../index.html";

# 文字コード自動判別（0=no 1=yes）
# → フォーム入力の文字コード判別を行う場合
$cf{conv_code} = 0;

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 250;	# 横幅
$cf{max_img_h} = 150;	# 縦幅

# アルバムサムネイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{alb_img_w} = 180;
$cf{alb_img_h} = 108;

# 投稿があるとメール通知する : sendmail必須
#  0 : 通知しない
#  1 : 通知する
$cf{mailing} = 0;

# メール通知する際のメールアドレス
$cf{mailto} = 'xxx@xxx.xx';

# sendmailパス（メール通知する時）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# ツリーのヘッダー記号
$cf{treehead} = "▼";

# ツリーのヘッダー記号
$cf{treehead_top} ='<img src="./cmn/ico/fld_nor.gif" border="0" style="vertical-align:middle;" title="一括表示" alt="一括表示">';

# クッキーID（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id}  = "web_forum";  # 投稿フォーム用
$cf{cookie_id2}  = "wf_ref";  # 参照フォーム追加用(新規投稿)
$cf{cookie_id3} = "wf_passwd";  # アクセス制限用
$cf{cookie_id4}  = "wf_refres";  # 参照フォーム追加用(返信投稿)

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '';

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = 'エルメス,バッグ,コピー,ブランド,殺人';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# １度の投稿で受理できる最大サイズ (bytes)
# → 1024Byte = 100KB
$cf{maxdata} = 51200000;

# 投稿制限
#  0 : しない
#  1 : 同一IPアドレスからの投稿間隔を制限する
#  2 : 全ての投稿間隔を制限する
$cf{regCtl} = 0;

# 制限投稿間隔（秒数）
#  → $regCtl での投稿間隔
$cf{wait} = 60;

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]

# 過去ログ機能 (0=no 1=yes)
$cf{pastkey} = 1;

# 過去ログカウントファイル【サーバパス】
$cf{nofile} = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
$cf{pastdir} = './data/past';

# 過去ログ１ページ当りの最大行数
#  → これを超えると自動的に次ファイルを生成します
$cf{max_line} = 650;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captchaforum';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "caligraphy_blue.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "dejavusans.ttf";

#============================================================
# ■ 設定完了
#============================================================

# フォルダーアイコン
$cf{fld_icon} = {
	0 => 'fld_lock.gif',
	1 => 'folder.gif',
	2 => 'solved_lock.gif',
	image => 'folder_attach.png',
	};

# レスアイコン
$cf{res_icon} = {
	res_lock => 'page_white_lock.gif',
	res_normal => 'page_white_text.gif',
	res_lock_user => 'page_white_solved01.gif',
	res_image => 'file_attach.png',
	};

# 著作権表記（削除厳禁）
$cf{copyright} = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">WebForum</a> -<br />
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

# ハッシュを返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if (!/^upfile\d$/) {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行変換
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\n\r]|<br />|g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー処理
#-----------------------------------------------------------
sub error {
	my $msg = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!error!/$msg/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{icourl}/$1">|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	footer();

	exit;
}

#-----------------------------------------------------------
#  時間取得
#-----------------------------------------------------------
sub get_time {
	my ($time, $log) = @_;
	$time ||= time;

	# 時間取得
	my ($sec,$min,$hour,$day,$mon,$year,$wday) = (localtime($time))[0..6];

	# ツリー表示
	if ($log eq "log") {
		my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;
		sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$day,$week[$wday],$hour,$min);

	# 記事閲覧
	} else {
		my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;
		sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
				$year+1900,$mon+1,$day,$week[$wday],$hour,$min,$sec);
	}
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	if (!$w) { $w = 1; }
	if (!$h) { $h = 1; }

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { &pwd_form; }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { &error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { &pwd_form; }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			&error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			&pwd_form;
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="http://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  画像表記
#-----------------------------------------------------------
sub put_image1 {

	my ($no,$sub,$name,$msg,$e1,$w1,$h1,$imgtxt1) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e1})) {
		my $size = get_size("$cf{upldir}/$no-1$e1");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-1$e1" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e1}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e1 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s-1$e1") {
		$op = qq|src="$cf{uplurl}/$no-s-1$e1"|;
		} else {
			my ($w,$h) = resize($w1,$h1);
			$op = qq|src="$cf{uplurl}/$no-1$e1" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-1$e1" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt1" data-lightview-group-options="skin: 'mac'"><div class="snap"><img $op class="snapshot" alt="$no-s-1$e1"></a><br />$imgtxt1</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_image2 {

	my ($no,$sub,$name,$msg,$e2,$w2,$h2,$imgtxt2) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e2})) {
		my $size = get_size("$cf{upldir}/$no-2$e2");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-2$e2" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e2}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e2 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s-2$e2") {
		$op = qq|src="$cf{uplurl}/$no-s-2$e2"|;
		} else {
			my ($w,$h) = resize($w2,$h2);
			$op = qq|src="$cf{uplurl}/$no-2$e2" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-2$e2" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt2" data-lightview-group-options="skin: 'mac'"><div class="snap"><img $op class="snapshot" alt="$no-2$e2"></a><br />$imgtxt2</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_image3 {

	my ($no,$sub,$name,$msg,$e3,$w3,$h3,$imgtxt3) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e3})) {
		my $size = get_size("$cf{upldir}/$no-3$e3");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-3$e3" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e3}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e3 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s-3$e3") {
		$op = qq|src="$cf{uplurl}/$no-s-3$e3"|;
		} else {
			my ($w,$h) = resize($w3,$h3);
			$op = qq|src="$cf{uplurl}/$no-3$e3" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-3$e3" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt3" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-3$e3"></a><br />$imgtxt3</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_image4 {

	my ($no,$sub,$name,$msg,$e4,$w4,$h4,$imgtxt4) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e4})) {
		my $size = get_size("$cf{upldir}/$no-4$e4");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-4$e4" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e4}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e4 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s-4$e4") {
		$op = qq|src="$cf{uplurl}/$no-s-4$e4"|;
		} else {
			my ($w,$h) = resize($w4,$h4);
			$op = qq|src="$cf{uplurl}/$no-4$e4" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-4$e4" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt4" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-4$e4"></a><br />$imgtxt4</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_image5 {

	my ($no,$sub,$name,$msg,$e5,$w5,$h5,$imgtxt5) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e5})) {
		my $size = get_size("$cf{upldir}/$no-5$e5");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-5$e5" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e5}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e5 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s-5$e5") {
		$op = qq|src="$cf{uplurl}/$no-s-5$e5"|;
		} else {
			my ($w,$h) = resize($w5,$h5);
			$op = qq|src="$cf{uplurl}/$no-5$e5" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-5$e5" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt5" data-lightview-group-options="skin: 'mac'"><div class="snap"><img $op  class="snapshot" alt="$no-5$e5"></a><br />$imgtxt5</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

#-----------------------------------------------------------
#  検索画面画像表記
#-----------------------------------------------------------
sub put_find1 {

	my ($no,$msg,$e1,$w1,$h1,$imgtxt1) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e1})) {
		my $size = get_size("$cf{upldir}/$no-1$e1");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-1$e1" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e1}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e1 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s1$e1") {
		$op = qq|src="$cf{uplurl}/$no-s1$e1"|;
		} else {
			my ($w,$h) = resize($w1,$h1);
			$op = qq|src="$cf{uplurl}/$no-1$e1" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-1$e1" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt1" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-1$e1"></a><br />$imgtxt1</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_find2 {

	my ($no,$msg,$e2,$w2,$h2,$imgtxt2) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e2})) {
		my $size = get_size("$cf{upldir}/$no-2$e2");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-2$e2" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e2}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e2 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s2$e2") {
		$op = qq|src="$cf{uplurl}/$no-s2$e2"|;
		} else {
			my ($w,$h) = resize($w2,$h2);
			$op = qq|src="$cf{uplurl}/$no-2$e2" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-2$e2" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt2" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-2$e2"></a><br />$imgtxt2</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_find3 {

	my ($no,$msg,$e3,$w3,$h3,$imgtxt3) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e3})) {
		my $size = get_size("$cf{upldir}/$no-3$e3");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-3$e3" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e3}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e3 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s3$e3") {
		$op = qq|src="$cf{uplurl}/$no-s3$e3"|;
		} else {
			my ($w,$h) = resize($w3,$h3);
			$op = qq|src="$cf{uplurl}/$no-3$e3" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-3$e3" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt3" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-3$e3"></a><br />$imgtxt3</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_find4 {

	my ($no,$msg,$e4,$w4,$h4,$imgtxt4) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e4})) {
		my $size = get_size("$cf{upldir}/$no-4$e4");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-4$e4" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e4}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e4 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s4$e4") {
		$op = qq|src="$cf{uplurl}/$no-s4$e4"|;
		} else {
			my ($w,$h) = resize($w4,$h4);
			$op = qq|src="$cf{uplurl}/$no-4$e4" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-4$e4" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt4" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-4$e4"></a><br />$imgtxt4</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}

sub put_find5 {

	my ($no,$msg,$e5,$w5,$h5,$imgtxt5) = @_;

	my ($op,$img);
	# 指定アイコン
	if (defined($cf{icons}{$e5})) {
		my $size = get_size("$cf{upldir}/$no-5$e5");
		$img .= qq|<div id="attach02"><a href="$cf{uplurl}/$no-5$e5" target="_blank"><img src="$cf{icourl}/$cf{icons}{$e5}" alt="" class="icon" /></a> ($size)</div>\n|;

	# 画像の場合
	} elsif ($e5 =~ /(jpg|png|gif)$/) {
		if (-f "$cf{upldir}/$no-s5$e5") {
		$op = qq|src="$cf{uplurl}/$no-s5$e5"|;
		} else {
			my ($w,$h) = resize($w5,$h5);
			$op = qq|src="$cf{uplurl}/$no-5$e5" width="$w" height="$h"|;
		}
		$img .= qq|<a href="$cf{uplurl}/$no-5$e5" class="lightview" data-lightview-title="No.$no imagetitle:$imgtxt5" data-lightview-group-options="skin: 'mac'"><div class="snap"><img class="snapshot" $op alt="$no-5$e5"></a><br />$imgtxt5</div>|;
	}
	if ($img) {
		return "$msg<p>$img</p>";
	} else {
		return $msg;
	}
}


1;

